using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.IO;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                this.Text = "bmp2array "+openFileDialog1.FileName;
                pictureBox1.Image = Image.FromFile(openFileDialog1.FileName);
            }
            pictureBox2.Image = null;
            progressBar1.Value = 0;
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Bitmap bit_map1 = new Bitmap(openFileDialog1.FileName);
            Bitmap bit_map2 = new Bitmap(200, 48, PixelFormat.Format32bppArgb);
            String str = "";
            Int32 pix,x,y;
            StreamWriter writer = new StreamWriter(
                                        openFileDialog1.FileName+".c",
                                        false,
                                        Encoding.GetEncoding("Shift_JIS")
                                       );
            writer.WriteLine("const struct rgb vrom[200][48]={");
            for (x = 0; x < 200; x++)
            {
                str = "";
                for (y = 0; y < 48; y++)
                {
                    pix = (x < bit_map1.Width && y < bit_map1.Height) 
                        ? bit_map1.GetPixel(x,y).ToArgb()
                        : (Int32) 0x000000;
                    pix = (Int32)(pix & 0xfffcfcfc);    //  0xfc=0b1111 1100
                    bit_map2.SetPixel(x,y,Color.FromArgb(pix));
                    pix=pix>>2;
                    str +="{"+          //0x3f=0b0011 1111
                        "0x" + ((pix & 0x003f0000)>>16).ToString("x2")+","+
                        "0x" + ((pix & 0x00003f00) >> 8).ToString("x2") + "," +
                        "0x" + ((pix & 0x0000003f)).ToString("x2") + "},";
                }
                writer.WriteLine("{"+str+"},");
                progressBar1.Value = x / 2;
           }
           writer.WriteLine("};");
           writer.Close();
           pictureBox2.Image = bit_map2;
        }
    }
}